;********************************************************************
; AA UT2FW firmware source code. Initially generated from UT2FW demo
; by WinDis84, (c) Nigel Goodwin 1998, then this code was heavily
; modified by Vadim Demidov
; Released to public domain 20 March 2011 at CQHAM.ru
;********************************************************************

		;;LIST		P=16F819, F=INHX8M
		include		"P16F819.inc"

	__idlocs	H'819'
	__CONFIG	_CP_OFF & _WDT_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _PWRTE_ON & _INTRC_IO

;	DDS type settings

#define DDS_AD9834	0	; 0 for AD9835, 1 for AD9834

;	Keyboard and display timing settings (in 5ms units)

#define DBN_TICKS	D'10'	; 10*5ms=50ms debounce time
#define WAI_TICKS	D'200'	; 200*5ms=1s wait before repeat
#define RPT_TICKS	D'70'	; 70*5ms=350ms repeat period, less than WAI_TICKS
#define UPD_TICKS	D'100'	; 100*5ms=500ms update period, when no key is pressed

;	Sampling frequency settings

#define F0_60_00	0	; Original 60 MHz
#define F0_66_67	1	; 66.667 MHz
#define F0_75_00	2	; 75 MHz
#define F0_80_00	3	; 80 MHz
#define F0_66_00	4	; 66 MHz

;#define F0_value	F0_60_00
;#define F0_value	F0_66_67
;#define F0_value	F0_75_00
#define F0_value	F0_80_00
;#define F0_value	F0_66_00

;	Patching mode settings

#define MOD_ORIG	0	; No code modification
#define MOD_FULL	1	; Squeezed code

;#define MOD_type	MOD_ORIG
#define MOD_type	MOD_FULL

;	Set_freq takes frequency value in Hertz as 32-bit integer
;	in Rgx_ll-Rgx_hh and converts it into DDS tuning word FTW.
;	Since N=F*A/F0 all we need is to multiply F by (A/F0),
;	where A=2**32 and F0 is sampling frequency in Hertz. For
;	convenience we calculate K=N*(2**24)=F*(2**56)/F0. This
;	multiplier for F0=67.89 MHz is 3F437CBB (actually 3F437CBA)
;	3f 43 7c ba - for 67.89 MHz

 if F0_value == F0_60_00		; (2^56)/60000000 -> 4795319C
		F0_val_B3	EQU	0x47
		F0_val_B2	EQU	0x95
		F0_val_B1	EQU	0x31
		F0_val_B0	EQU	0x9C
 else
  if F0_value == F0_66_67	; (2^56)/66666666 -> 406CACB1
		F0_val_B3	EQU	0x40
		F0_val_B2	EQU	0x6c
		F0_val_B1	EQU	0xAC
		F0_val_B0	EQU	0xB1
  else
	if F0_value == F0_75_00	; (2^56)/75000000 -> 394427B1
		F0_val_B3	EQU	0x39
		F0_val_B2	EQU	0x44
		F0_val_B1	EQU	0x27
		F0_val_B0	EQU	0xB1
	else
	  if F0_value == F0_80_00 ; (2^56)/80000000 -> 35AFE535
		F0_val_B3	EQU	0x35
		F0_val_B2	EQU	0xAF
		F0_val_B1	EQU	0xE5
		F0_val_B0	EQU	0x35
	  else
		if F0_value == F0_66_00	; (2^56)/66000000 -> 41134460
		  F0_val_B3	EQU	0x41
		  F0_val_B2	EQU	0x13
		  F0_val_B1	EQU	0x44
		  F0_val_B0	EQU	0x60
		else
		  error "Unknown F0 value"
		endif
	  endif
	endif
  endif
 endif

#define P16_MAP1	0	; Needed for memory map selection in P16F819.inc
#define P16_MAP2	1

		include "MATH16.inc"

;	Bit assignments for I/O pins

PA_COM_TXD	EQU		4	; COM port Transmit Data
PA_LCD_EN	EQU		6	; LCD Enable
PA_LCD_RS	EQU		7	; LCD Register Select

PB_DDS_SDT	EQU		0	; DDS Serial Data
PB_DDS_SCK	EQU		1	; DDS Serial Clock
PB_DDS_NCS	EQU		4	; DDS Negative Chip Select

;	Bit assignments for Flags

Fl_itmr		EQU		0	; ISR timer expired
Fl_fmin		EQU		1
Fl_fmax		EQU		2
Fl_krdy		EQU		3	; Keystroke ready
Fl_keyp		EQU		4	; Key pressed (debounced)

Fl_upd5		EQU		5	; Not analysed, only set/seset in orig version
						; Update flag in new version

Fl_frgn		EQU		6	; DDs Frequency register 0/1
Fl_clbr		EQU		7	; Calibration mode on

;	Bit assignments for New Flags

Nf_echo		EQU		0	; Echo to serial port

;	Locations 0x20-0x34 are used by FP library
;	Locations 0x35-0x4b seem free

PB_curr		EQU		0x4c
PB_prev		EQU		0x4d
Dbn_cnt		EQU		0x4e	; Debounce keyboard counter
Wtr_cnt		EQU		0x4f	; Wait and repeat keyboard counter
FTW_ll		EQU		0X50
FTW_lh		EQU		0X51
FTW_hl		EQU		0X52
FTW_hh		EQU		0X53
FTW_ul		EQU		0x54
Cmn_bcnt	EQU		0x55
DDS_wrdl	EQU		0x56
DDS_wrdh	EQU		0x57
Stp_ndx		EQU		0x58
Stp_ptr		EQU		0x59
Fstep_ll	EQU		0x5a
Fstep_lh	EQU		0x5b
Fstep_hl	EQU		0x5c
Fstep_hh	EQU		0x5d
Rg_bcd_0	EQU		0x5e
Rg_bcd_1	EQU		0x5f
Rg_bcd_2	EQU		0x60
Rg_bcd_3	EQU		0x61
Rg_bcd_4	EQU		0x62
Bcd_shcnt	EQU		0x63
Bcd_tmp		EQU		0x64
Dl1cth		EQU		0x65
Dl1ctl		EQU		0x66
 if MOD_type != MOD_FULL
Dl2cnt		EQU		0x67	; not used
 else
Nflgs		EQU		0x67	; New flags
 endif
Sym_LCD		EQU		0x68
;	Location 0x69 seems free
 if MOD_type == MOD_FULL
S_Wtemp		EQU		0x69
 endif
Flags		EQU		0x6a
Isr_tmr		EQU		0x6b
Mv4_sptr	EQU		0x6c
Mv4_dptr	EQU		0x6d
Mv4_tmpv	EQU		0x6e
Mv4_cntr	EQU		0x6f
Int_sav_W	EQU		0x70
Int_sav_STS	EQU		0x71
Int_sav_PCH	EQU		0x72
;	Location 0x73 seems free
 if MOD_type == MOD_FULL
S_count		EQU		0x73
 endif
Rgx_hh		EQU		0x74
Rgx_hl		EQU		0x75
Rgx_lh		EQU		0x76
Rgx_ll		EQU		0x77
Vi_h		EQU		0x78
Vi_l		EQU		0x79
V50h		EQU		0x7a
V50l		EQU		0x7b
Vo_h		EQU		0x7c
Vo_l		EQU		0x7d
Z0_ptr		EQU		0x7e
;	Location 0x7F seems free
Rgy_hh		EQU		0xa0	; 0xa0-0xa3
Fp_r0		EQU		0xa4	; 0xa4-0xa7
Fp_r1		EQU		0xa8	; 0xa8-0xab
Fp_r2		EQU		0xac	; 0xac-0xaf
Fp_r3		EQU		0xb0	; 0xb0-0xb3
Fp_r4		EQU		0xb4	; 0xb4-0xb7
Fp_r5		EQU		0xb8	; 0xb8-0xbb
Fp_r6		EQU		0xbc	; 0xbc-0xbf
Fp_r7		EQU		0xc0	; 0xc0-0xc3
Fp_sq_a		EQU		0xc4	; 0xc4-0xc7
Fp_sq_b		EQU		0xc8	; 0xc8-0xcb
Fp_r8		EQU		0xcc	; 0xcc-0xcf
Fp_r9		EQU		0xd0	; 0xd0-0xd3
Fp_rA		EQU		0xd4	; 0xd4-0xd7

;	Locations 0xd8-0xef seem free

;	Cold start

		ORG		0x0000

 if MOD_type == MOD_FULL
		MOVLW	0x40
		MOVWF	INTCON
		MOVLW	0x00
 endif
		GOTO	Start

;	Interrupt service routine. Only Timer 1 can cause interrupts.
;	For 8MHz/4 input clock and 10000 setting it happens once per
;	5ms. For keyboard repeat rate 100*5ms=500ms is generated in
;	software (Fl_itmr). For debouncing a single 5ms period is used.

		ORG		0x0004

		MOVWF	Int_sav_W
		SWAPF	STATUS, W
		MOVWF	Int_sav_STS
		MOVF	PCLATH, W
		MOVWF	Int_sav_PCH
		BCF		STATUS, RP0
 if MOD_type == MOD_FULL
		BCF		STATUS, RP1
 endif
 if MOD_type != MOD_FULL
		GOTO	ISR_cont

Fstp_tbl
		ADDWF	PCL, f
		RETLW	0x00	; 0x000003e8=1000
		RETLW	0x00
		RETLW	0x03
		RETLW	0xE8

		RETLW	0x00	; 0x00002710=10000
		RETLW	0x00
		RETLW	0x27
		RETLW	0x10

		RETLW	0x00	; 0x000186a0=100000
		RETLW	0x01
		RETLW	0x86
		RETLW	0xA0

		RETLW	0x00	; 0x000f4240=1000000
		RETLW	0x0F
		RETLW	0x42
		RETLW	0x40

Z0_tbl
		ADDWF	PCL, f
		RETLW	0x88	; 88 16 (00 00) -> (2^(0x88-0x7F))*(0x96/128) = 600
		RETLW	0x16
		RETLW	0x87	; 87 16 (00 00) -> (2^(0x87-0x7F))*(0x96/128) = 300
		RETLW	0x16
		RETLW	0x85	; 85 16 (00 00) -> (2^(0x85-0x7F))*(0x96/128) = 75
		RETLW	0x16
		RETLW	0x84	; 84 48 (00 00) -> (2^(0x84-0x7F))*(0xC8/128) = 50
		RETLW	0x48

  if MOD_type != MOD_FULL
;---------------- unused code start
		ADDWF	PCL, f
		RETLW	0x00	; 0x000f4240=1000000
		RETLW	0x0F
		RETLW	0x42
		RETLW	0x40

		ADDWF	PCL, f
		RETLW	0x01	; 0x01c9c380=30000000
		RETLW	0xC9
		RETLW	0xC3
		RETLW	0x80
;---------------- unused code end
  endif

ISR_cont
 endif
 if MOD_type != MOD_FULL
 		BTFSC	PIR1, TMR1IF	; Timer 1 Interrupt flag
		GOTO	ISR_3

		BCF		PIR1, ADIF	; ADC interrupt flag
		GOTO	ISR_end

ISR_3						; TMR1IF on - timer interrupt
 endif
		BCF		T1CON, TMR1ON
		DECF	Isr_tmr, f	; Software timer
 if MOD_type != MOD_FULL
		BNZ		ISR_5		; Not zero yet

		BSF		Flags, Fl_itmr	; Software timer flag
		MOVLW	UPD_TICKS	; Reload counter: 100*5ms=0.5s
		MOVWF	Isr_tmr

ISR_5
 else
		BTFSC	STATUS, Z
		BSF		Flags, Fl_itmr	; Software timer flag
 endif
		MOVF	PORTB, W	; Read keyboard
		MOVWF	PB_curr
		SWAPF	PB_curr, f
		RRF		PB_curr, f
		MOVF	PB_curr, W	; Keys in bits [2:0]
		ANDLW	B'00000111'
		MOVWF	PB_curr		; Keep
		XORWF	PB_prev, W	; Any change from previous readings
		BTFSC	STATUS, Z	; Z for no change
		GOTO	ISR_6		; Same readings

 if MOD_type != MOD_FULL
		MOVF	Dbn_cnt, W	; Previous readings duration?
		BZ		ISR_7		; Still zero?

		DECF	Dbn_cnt, f	; Not zero, was one?
		BNZ		ISR_ldtmr	; Not 0 or 1

ISR_7						; Dbn_cnt was 0 or 1 - too short?
 endif
		CLRF	Dbn_cnt		; New readings - restart counters
		CLRF	Wtr_cnt
		BCF		Flags, Fl_keyp
 if MOD_type != MOD_FULL
		BCF		Flags, Fl_upd5	; Not analysed, only set/seset
 endif
		MOVF	PB_curr, W
		MOVWF	PB_prev		; Update state
		GOTO	ISR_ldtmr

ISR_6						; Same keyboard readings
		MOVLW	B'00000111'
		XORWF	PB_prev, W
		BTFSC	STATUS, Z	; Z for all keys open B'111"
		GOTO	ISR_ldtmr	; All open - ignore

		BTFSS	Flags, Fl_keyp	; Key debounced?
		GOTO	ISR_9		; Not yet

		INCF	Wtr_cnt, f	; First cycle from 0 to 200
		MOVLW	WAI_TICKS	; 200*5ms=1s - wait before repeating
		XORWF	Wtr_cnt, W
		BNZ		ISR_ldtmr	; Not yet

 if MOD_type != MOD_FULL
		MOVLW	D'199'		; Yes, reload for short repeat (5ms)
 else
		MOVLW	WAI_TICKS-RPT_TICKS	; Repeat period (200-130)*5ms=350ms
 endif
		MOVWF	Wtr_cnt
 if MOD_type != MOD_FULL
		BSF		Flags, Fl_upd5	; Not analysed, only set/seset
 endif
		BSF		Flags, Fl_krdy
		GOTO	ISR_ldtmr

ISR_9
		INCF	Dbn_cnt, f
 if MOD_type != MOD_FULL
		MOVLW	D'20'		; 5ms*20=100ms debounce time
 else
		MOVLW	DBN_TICKS	; 5ms*10=50ms debounce time
 endif
		XORWF	Dbn_cnt, W	; Repeat counter is OK?
		BNZ		ISR_ldtmr

		BSF		Flags, Fl_keyp	; Key debounced
		BSF		Flags, Fl_krdy	; And mark new keystroke
 if MOD_type != MOD_FULL
;---------------- unused code start
		GOTO	ISR_ldtmr
;---------------- unused code end
 endif

ISR_ldtmr
		MOVLW	0xD8	; FFFF - D8EF = 2710 -> 10000 (5ms on 8MHz)
		MOVWF	TMR1H
		MOVLW	0xEF
		MOVWF	TMR1L
		BCF		PIR1, TMR1IF	; Timer 1 Interrupt flag
		BSF		T1CON, TMR1ON

 if MOD_type != MOD_FULL
ISR_end
 endif
		MOVF	Int_sav_PCH, W
		MOVWF	PCLATH
		SWAPF	Int_sav_STS, W
		MOVWF	STATUS
		SWAPF	Int_sav_W, f
		SWAPF	Int_sav_W, W
		RETFIE

Start
 if MOD_type != MOD_FULL
		CLRF	STATUS
		BCF		STATUS, RP0
		MOVLW	0x40
		MOVWF	INTCON
		MOVLW	0x00
 endif
		MOVWF	PORTA
 if MOD_type != MOD_FULL
		MOVLW	0x00
 endif
		MOVWF	PORTB
		BSF		STATUS, RP0
 if MOD_type != MOD_FULL
		MOVLW	B'00011111';0x1F
 else
		MOVLW	B'00001111'; Enable serial data bit
 endif
		MOVWF	TRISA
		MOVLW	B'11100000';0xE0
		MOVWF	TRISB
		MOVLW	0x00
		MOVWF	OPTION_REG
		CLRF	PIE1		; ### 0 at power-on
		BSF		PIE1, TMR1IE	; Timer 1 Interrupt enable
		CLRF	PIE2		; ### 0 at power-on
		CLRF	PCON		; ### ??
		CLRF	SSPSTAT		; ### 0 at power-on
		MOVLW	0x74
		MOVWF	OSCCON		; IRCF[2:0]=7 (8MHz int.) IOFS=1 - R/O bit!
		MOVLW	B'11101100';0xEC
		MOVWF	TRISB
		BCF		STATUS, RP0
		MOVF	PORTB, W
		ANDLW	B'00001100';0x0C
		MOVWF	Z0_ptr
 if MOD_type != MOD_FULL
		BCF		STATUS, C
		RRF		Z0_ptr, f
 endif
		BSF		STATUS, RP0
		MOVLW	B'11100000';0xE0
		MOVWF	TRISB
		BCF		STATUS, RP0
		CLRF	T1CON		; ### 0 at power-on
		CLRF	T2CON
		CLRF	CCP1CON		; ### 0 at power-on
		CLRF	SSPCON		; ### 0 at power-on
		CLRF	PIR1		; ### 0 at power-on
		CLRF	PIR2		; ### 0 at power-on
		CLRF	Flags
 if MOD_type == MOD_FULL
		CLRF	Nflgs
		CLRF	FPFLAGS
		BSF		FPFLAGS, SAT	; Set saturation mode
 endif
		CALL	LCD_init

 if MOD_type == MOD_FULL
		BSF		PORTA, PA_COM_TXD	; Stop bit
 endif

		BSF		PORTB, PB_DDS_NCS	; Deselect DDS
 if DDS_AD9834
		MOVLW	B'00100001'	; DDS: B28, RESET
		MOVWF	DDS_wrdh
		MOVLW	B'10000000'	; DDS: SLEEP1
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16

		MOVLW	B'00100000'	; DDS: B28
		MOVWF	DDS_wrdh
		MOVLW	B'00000000'	; DDS:
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
 else
		MOVLW	0xF8	; DDS: SLEEP, RESET, CLR
		MOVWF	DDS_wrdh
		CALL	Snd_wrd16
		MOVLW	0xB0	; DDS: SYNC, SELSRC
		MOVWF	DDS_wrdh
		CALL	Snd_wrd16
		MOVLW	0xC0	; DDS: resetting SLEEP, RESET, CLR
		MOVWF	DDS_wrdh
		CALL	Snd_wrd16
 endif
		MOVLW	0x01
		MOVWF	Stp_ndx
		CALL	Sel_fstp
 if MOD_type == MOD_FULL
		MOVLW	Strt_fq
		MOVWF	Mv4_sptr
		MOVLW	Rgx_hh	; MSB first
		CALL	EE4_SpW
 else
		MOVLW	0x00	; 0x006b9310=7050000
		MOVWF	Rgx_hh
		MOVLW	0x6B
		MOVWF	Rgx_hl
		MOVLW	0x93
		MOVWF	Rgx_lh
		MOVLW	0x10
		MOVWF	Rgx_ll
 endif
		MOVLW	D'40'
		MOVWF	Isr_tmr		; 40*5ms=200ms for first cycle
		CALL	bin2bcd
		CALL	LCD_freq
		CALL	Set_freq
		BCF		STATUS, RP0	; ### ?
		MOVLW	0xD8		; ffff-d8ef=2710 (10000)
		MOVWF	TMR1H		; 0.5us*10000=5ms (8/4=2MHz->0.5us)
		MOVLW	0xEF
		MOVWF	TMR1L
		BCF		PIR1, TMR1IF	; Timer 1 Interrupt flag
		BSF		T1CON, TMR1ON
		BSF		INTCON, GIE

; Main loop

Mn_loop
		BCF		INTCON, GIE
		BSF		STATUS, RP0
 if MOD_type == MOD_FULL
		MOVLW	0xC4		; To enable digital mode on AN4 (and AN2)
 else
		MOVLW	0xC1
 endif
		MOVWF	ADCON1		; ADFM=1, ADCS2=1, PCFG[3:0]=4 (was 1)
		BCF		STATUS, RP0

		MOVLW	0x41		; ADCS[1:0]=01, CHS[2:0]=0, ADON=1
		MOVWF	ADCON0
 if MOD_type == MOD_FULL
		call	Rd_ADC
		movwf	V50l
		MOVF	ADRESH, W
		movwf	V50h
 else
		CALL	Dly_20us
		BSF		ADCON0, GO_DONE
Label_0011
		BTFSC	ADCON0, GO_DONE
		GOTO	Label_0011

		MOVF	ADRESH, W
		MOVWF	AARGB1
		BSF		STATUS, RP0
		MOVF	ADRESL, W
		BCF		STATUS, RP0
		MOVWF	AARGB0
		MOVF	AARGB0, W
		ADDWF	V50l, f
		BTFSC	STATUS, C
		INCF	V50h, f
		MOVF	AARGB1, W
		ADDWF	V50h, f
		BCF		STATUS, C
		RRF		V50h, f
		RRF		V50l, f
 endif

		MOVLW	0x49		; CHS[2:0]=1
		MOVWF	ADCON0
 if MOD_type == MOD_FULL
		call	Rd_ADC
		movwf	Vi_l
		MOVF	ADRESH, W
		movwf	Vi_h
 else
		CALL	Dly_20us
		BSF		ADCON0, GO_DONE
Label_0012
		BTFSC	ADCON0, GO_DONE
		GOTO	Label_0012

		MOVF	ADRESH, W
		MOVWF	AARGB1
		BSF		STATUS, RP0
		MOVF	ADRESL, W
		BCF		STATUS, RP0
		MOVWF	AARGB0
		MOVF	AARGB0, W
		ADDWF	Vi_l, f
		BTFSC	STATUS, C
		INCF	Vi_h, f
		MOVF	AARGB1, W
		ADDWF	Vi_h, f
		BCF		STATUS, C
		RRF		Vi_h, f
		RRF		Vi_l, f
 endif

		MOVLW	0x51
		MOVWF	ADCON0	; CHS[2:0]=2
 if MOD_type == MOD_FULL
		call	Rd_ADC
		movwf	Vo_l
		MOVF	ADRESH, W
		movwf	Vo_h
 else
		CALL	Dly_20us
		BSF		ADCON0, GO_DONE
Label_0013
		BTFSC	ADCON0, GO_DONE
		GOTO	Label_0013

		MOVF	ADRESH, W
		MOVWF	AARGB1
		BSF		STATUS, RP0
		MOVF	ADRESL, W
		BCF		STATUS, RP0
		MOVWF	AARGB0
		MOVF	AARGB0, W
		ADDWF	Vo_l, f
		BTFSC	STATUS, C
		INCF	Vo_h, f
		MOVF	AARGB1, W
		ADDWF	Vo_h, f
		BCF		STATUS, C
		RRF		Vo_h, f
		RRF		Vo_l, f
 endif

		BCF		PIR1, ADIF	; ADC interrupt flag
		BSF		INTCON, GIE
 if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_upd5	; Update flag in new version
		GOTO	Sel_mode

		BTFSS	Flags, Fl_itmr	; Update SRX or Voltage display
		GOTO	mnl_chkbd

Sel_mode
 endif
		BTFSC	Flags, Fl_clbr
		GOTO	mnl_cal

		CALL	Do_calc
		CALL	LCD_SRX
 if MOD_type == MOD_FULL
		GOTO	mnl_clr5_chk
 else
		GOTO	mnl_chkbd
 endif

mnl_cal
 if MOD_type != MOD_FULL
		BTFSS	Flags, Fl_itmr
		GOTO	mnl_chkbd
 endif

		CALL	LCD_3_volts
 if MOD_type != MOD_FULL
		BCF		Flags, Fl_itmr
 else
mnl_clr5_chk
		BCF		Flags, Fl_upd5	; Update flag in new version
		BCF		Flags, Fl_itmr
		MOVLW	UPD_TICKS	; 100*5ms=500ms
		MOVWF	Isr_tmr

 endif

mnl_chkbd
 if MOD_type == MOD_FULL
		BTFSS	Flags, Fl_krdy
		GOTO	Mn_loop
 else
		BTFSC	Flags, Fl_krdy
		GOTO	mnl_dokey

		GOTO	Mn_loop

mnl_dokey
 endif
		BCF		Flags, Fl_krdy
		MOVLW	0x06	; B'110' Up
		XORWF	PB_prev, W
		BZ		Inc_frq

		MOVLW	0x05	; B'101' Down
		XORWF	PB_prev, W
		BZ		Dec_frq

		MOVLW	0x03	; B'011' Step
		XORWF	PB_prev, W
		BZ		Chng_step

		MOVLW	0x04	; B'100' Up & Down - Menu
		XORWF	PB_prev, W
		BZ		Tog_clbr

		GOTO	Mn_loop

Clr_krdy
 if MOD_type != MOD_FULL
		BCF		Flags, Fl_krdy
 endif
		GOTO	Mn_loop

 if MOD_type == MOD_FULL
Rd_ADC
		CALL	Dly_20us
		BSF		ADCON0, GO_DONE
Rda_wt
		BTFSC	ADCON0, GO_DONE
		GOTO	Rda_wt

		BSF		STATUS, RP0
		MOVF	ADRESL, W
		BCF		STATUS, RP0
		RETURN
 endif

Dly_20us				; Initially 18 GOTOs and RET, 38 (40) clocks
 if MOD_type != MOD_FULL
		GOTO	Label_001F
Label_001F
		GOTO	Label_0020
Label_0020
		GOTO	Label_0021
Label_0021
		GOTO	Label_0022
Label_0022
		GOTO	Label_0023
Label_0023
		GOTO	Label_0024
Label_0024
		GOTO	Label_0025
Label_0025
		GOTO	Label_0026
Label_0026
		GOTO	Label_0027
Label_0027
		GOTO	Label_0028
Label_0028
		GOTO	Label_0029
Label_0029
		GOTO	Label_002A
Label_002A
		GOTO	Label_002B
Label_002B
		GOTO	Label_002C
Label_002C
		GOTO	Label_002D
Label_002D
		GOTO	Label_002E
Label_002E
		GOTO	Label_002F
Label_002F
		GOTO	Label_0030
Label_0030
 else
		MOVLW	0x100-9			; (1) N=9
dl20_0
		addlw	0x01		; (1)
		bnz		dl20_0		; (3/2) 4*(N-1)+3=4*N-1=35

 endif
		RETURN				; (2)

Inc_frq
		CALL	Sel_fstp
		CALL	Stp_sub
		CALL	Flim_min
Cmn_incdecf
		BCF		INTCON, GIE
		CALL	Set_freq
		BSF		INTCON, GIE
		CALL	bin2bcd
 if MOD_type == MOD_FULL
		BSF		Flags, Fl_upd5	; Update flag in new version
 endif
		CALL	LCD_freq
		GOTO	Clr_krdy

Dec_frq
		CALL	Sel_fstp
		CALL	Stp_add
		CALL	Flim_max
 if MOD_type == MOD_FULL
		GOTO	Cmn_incdecf
 else
		BCF		INTCON, GIE
		CALL	Set_freq
		BSF		INTCON, GIE
		CALL	bin2bcd
  if MOD_type == MOD_FULL
		BSF		Flags, Fl_upd5	; Update flag in new version
  endif
		CALL	LCD_freq
		GOTO	Clr_krdy
 endif

Chng_step
		CALL	LCD_step
Ch_stp_loop
		BCF		Flags, Fl_krdy
Label_0037
		BTFSS	Flags, Fl_krdy
		GOTO	Label_0037

		MOVLW	0x05	; B'101' Down
		XORWF	PB_prev, W
		BZ		Stp_down

		MOVLW	0x06	; B'110' Up
		XORWF	PB_prev, W
		BZ		Stp_up

		MOVLW	0x03	; B'011' Step
		XORWF	PB_prev, W
		BZ		Stp_set

		GOTO	Ch_stp_loop

Stp_down
		INCF	Stp_ndx, f
		MOVLW	0x04
		XORWF	Stp_ndx, W
		BNZ		Label_003C

		MOVLW	0x03
		MOVWF	Stp_ndx
		GOTO	Label_003C

Stp_up
		DECF	Stp_ndx, f
		BTFSC	Stp_ndx, 07
		CLRF	Stp_ndx

Label_003C
		CALL	Sel_fstp
		CALL	LCD_step
		GOTO	Ch_stp_loop

Stp_set
		CALL	bin2bcd
		CALL	LCD_freq	; Restore frequency on LCD
		GOTO	Clr_krdy

Tog_clbr
		BTFSS	Flags, Fl_clbr
		GOTO	Label_003D

		BCF		Flags, Fl_clbr
		GOTO	Clr_krdy

Label_003D
		BSF		Flags, Fl_clbr
		GOTO	Clr_krdy

Sel_fstp
		MOVF	Stp_ndx, W
		MOVWF	Stp_ptr
		BCF		STATUS, C
		RLF		Stp_ptr, f
		RLF		Stp_ptr, f
		MOVF	Stp_ptr, W
 if MOD_type == MOD_FULL
		ADDLW	Tb_fstp
		MOVWF	Mv4_sptr
		MOVLW	Fstep_ll	; LSB first
		GOTO	EE4_SpW		; And return from there
 else
		CALL	Fstp_tbl
		MOVWF	Fstep_hh
		MOVF	Stp_ptr, W
		ADDLW	0x01
		CALL	Fstp_tbl
		MOVWF	Fstep_hl
		MOVF	Stp_ptr, W
		ADDLW	0x02
		CALL	Fstp_tbl
		MOVWF	Fstep_lh
		MOVF	Stp_ptr, W
		ADDLW	0x03
		CALL	Fstp_tbl
		MOVWF	Fstep_ll
		RETURN
 endif

;	Subtract step from frequency

Stp_sub
		COMF	Fstep_ll, f	; change sign of the step
		COMF	Fstep_lh, f
		COMF	Fstep_hl, f
		COMF	Fstep_hh, f
		INCFSZ	Fstep_ll, f
		GOTO	Stp_add

		INCFSZ	Fstep_lh, f
		GOTO	Stp_add

		INCFSZ	Fstep_hl, f
		GOTO	Stp_add

		INCF	Fstep_hh, f	; and fall to addition

;	Add step to frequency

Stp_add
		MOVF	Fstep_ll, W
		ADDWF	Rgx_ll, f
		BNC		Label_003F

		INCFSZ	Rgx_lh, f
		GOTO	Label_003F

		INCFSZ	Rgx_hl, f
		GOTO	Label_003F

		INCF	Rgx_hh, f
Label_003F
		MOVF	Fstep_lh, W
		ADDWF	Rgx_lh, f
		BNC		Label_0040

		INCFSZ	Rgx_hl, f
		GOTO	Label_0040

		INCF	Rgx_hh, f
Label_0040
		MOVF	Fstep_hl, W
		ADDWF	Rgx_hl, f
		BNC		Label_0041

		INCF	Rgx_hh, f
Label_0041
		MOVF	Fstep_hh, W
		ADDWF	Rgx_hh, f
		RETURN

;	Test frequency for maximum limit, adjust if needed

Flim_max
		BCF		Flags, Fl_fmax
		MOVLW	0x01
		SUBLW	0xFF
		ADDWF	Rgx_hh, W
		BC		Fl_stmax

		MOVLW	0x01
		SUBWF	Rgx_hh, W
		BNC		Flma_ret

		MOVLW	0xC9
		SUBLW	0xFF
		ADDWF	Rgx_hl, W
		BC		Fl_stmax

		MOVLW	0xC9
		SUBWF	Rgx_hl, W
		BNC		Flma_ret

		MOVLW	0xC3
		SUBLW	0xFF
		ADDWF	Rgx_lh, W
		BC		Fl_stmax

		MOVLW	0xC3
		SUBWF	Rgx_lh, W
		BNC		Flma_ret

		MOVLW	0x80
		SUBWF	Rgx_ll, W
		BTFSS	STATUS, C
Flma_ret
		RETURN

Fl_stmax
		BSF		Flags, Fl_fmax
		MOVLW	0x01	; 0x01c9c380=30000000
		MOVWF	Rgx_hh
		MOVLW	0xC9
		MOVWF	Rgx_hl
		MOVLW	0xC3
		MOVWF	Rgx_lh
		MOVLW	0x80
		MOVWF	Rgx_ll
		RETURN

;	Test frequency for minimum limit, adjust if needed

Flim_min
		BCF		Flags, Fl_fmin
		MOVF	Rgx_hh, W
		SUBLW	0xFF
		ADDLW	0x00		; 0x000f4240=1000000
		BC		Fl_stmin

		MOVF	Rgx_hh, W
		SUBLW	0x00
		BNC		Flmi_ret

		MOVF	Rgx_hl, W
		SUBLW	0xFF
		ADDLW	0x0F
		BC		Fl_stmin

		MOVF	Rgx_hl, W
		SUBLW	0x0F
		BNC		Flmi_ret

		MOVF	Rgx_lh, W
		SUBLW	0xFF
		ADDLW	0x42
		BC		Fl_stmin

		MOVF	Rgx_lh, W
		SUBLW	0x42
		BNC		Flmi_ret

		MOVF	Rgx_ll, W
		SUBLW	0x40
		BTFSS	STATUS, C
Flmi_ret
		RETURN

Fl_stmin
		BSF		Flags, Fl_fmin
		MOVLW	0x00		; 0x000f4240=1000000
		MOVWF	Rgx_hh
		MOVLW	0x0F
		MOVWF	Rgx_hl
		MOVLW	0x42
		MOVWF	Rgx_lh
		MOVLW	0x40
		MOVWF	Rgx_ll
		RETURN

;	Binary 32-bit to BCD conversion

bin2bcd
		MOVLW	D'32'
		MOVWF	Bcd_shcnt
		CLRF	Rg_bcd_0
		CLRF	Rg_bcd_1
		CLRF	Rg_bcd_2
		CLRF	Rg_bcd_3
		CLRF	Rg_bcd_4
F2bcd_loop
		BCF		STATUS, C
		RLF		Rgx_ll, f
		RLF		Rgx_lh, f
		RLF		Rgx_hl, f
		RLF		Rgx_hh, f
		BTFSC	STATUS, C
		BSF		Rgx_ll, 00
		RLF		Rg_bcd_0, f
		RLF		Rg_bcd_1, f
		RLF		Rg_bcd_2, f
		RLF		Rg_bcd_3, f
		RLF		Rg_bcd_4, f
		DECF	Bcd_shcnt, f
		BNZ		Label_0046

		RETURN

Label_0046
		MOVLW	Rg_bcd_0
		MOVWF	FSR
		CALL	BCD_corr
		INCF	FSR, f
		CALL	BCD_corr
		INCF	FSR, f
		CALL	BCD_corr
		INCF	FSR, f
		CALL	BCD_corr
		INCF	FSR, f
		CALL	BCD_corr
		GOTO	F2bcd_loop

BCD_corr
		MOVLW	0x03
		ADDWF	INDF, W
		MOVWF	Bcd_tmp
		BTFSC	Bcd_tmp, 03
		MOVWF	INDF
		MOVLW	0x30
		ADDWF	INDF, W
		MOVWF	Bcd_tmp
		BTFSC	Bcd_tmp, 07
		MOVWF	INDF
		RETURN

;	LCD initialization routine

LCD_init
		CALL	Dly_x21
		MOVLW	0x30
		CALL	LCD_cm_dly
		CALL	Dly_x21
		MOVLW	0x30
		CALL	LCD_cm_dly
		CALL	Dly_x21
		MOVLW	0x30
		CALL	LCD_cm_dly
		CALL	Dly_x21
		MOVLW	0x20
		CALL	LCD_cm_dly
		CALL	Dly_x21
		MOVLW	0x28
		CALL	LCD_cmd
		CALL	Dly_x21
		MOVLW	0x0C
		CALL	LCD_cmd
		CALL	Dly_x21
		MOVLW	0x06
		CALL	LCD_cmd
		MOVLW	0x40
		CALL	LCD_cmd
		MOVLW	0x00	; ........
		CALL	LCD_chr
		MOVLW	0x00	; ........
		CALL	LCD_chr
		MOVLW	0x0E	; ....***.
		CALL	LCD_chr
		MOVLW	0x11	; ...*...*
		CALL	LCD_chr
		MOVLW	0x11	; ...*...*
		CALL	LCD_chr
		MOVLW	0x0A	; ....*.*.
		CALL	LCD_chr
		MOVLW	0x1B	; ...**.**
		CALL	LCD_chr
		MOVLW	0x00	; ........
 if MOD_type == MOD_FULL
		GOTO	LCD_chr	; And return from there
 else
		CALL	LCD_chr
		RETURN
 endif

;	LCD command (in W) with additional delay

LCD_cm_dly
		BCF		PORTA, PA_LCD_RS
		MOVWF	Sym_LCD
		MOVLW	0xF0
		ANDWF	PORTB, f
		SWAPF	Sym_LCD, W
		ANDLW	0x0F
		IORWF	PORTB, f
		BSF		PORTA, PA_LCD_EN
		CALL	Dly_x48
		BCF		PORTA, PA_LCD_EN
		RETURN

;	Output of frequency value to LCD

LCD_freq
		MOVLW	0x80
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 endif
		SWAPF	Rg_bcd_3, W
		ANDLW	0x0F
		BZ		Label_004E

		CALL	LCD_dig
		GOTO	Label_0050

Label_004E
		MOVLW	' '
		CALL	LCD_chr
Label_0050
		MOVF	Rg_bcd_3, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		SWAPF	Rg_bcd_2, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		MOVF	Rg_bcd_2, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		SWAPF	Rg_bcd_1, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
 if MOD_type == MOD_FULL
		BTFSS	Flags, Fl_upd5	; Update flag in new version
		GOTO	no_ech2

		MOVLW	' '
		CALL	putchr

no_ech2
		BCF		Nflgs, Nf_echo
 endif
 if MOD_type == MOD_FULL
		MOVLW	Sng_kHz_sp
		GOTO	LCD_EEsngW	; And return from there
 else
		MOVLW	'k'
		CALL	LCD_chr
		MOVLW	'H'
		CALL	LCD_chr
		MOVLW	'z'
		CALL	LCD_chr
		MOVLW	' '
		CALL	LCD_chr
		RETURN
 endif

;	Output of frequency step value to LCD

LCD_step
		MOVLW	0x80
		CALL	LCD_cmd
 if MOD_type != MOD_FULL
		MOVLW	0x00
		XORWF	Stp_ndx, W
		BZ		LCD_st_1k

		MOVLW	0x01
		XORWF	Stp_ndx, W
		BZ		LCD_st_10k

		MOVLW	0x02
		XORWF	Stp_ndx, W
		BZ		LCD_st_100k

		MOVLW	0x03
		XORWF	Stp_ndx, W
		BZ		LCD_st_1M
 else
		MOVF	Stp_ndx, W
		BZ		LCD_st_1k	; Stp_ndx==0

		ADDLW	0xFF
		BZ		LCD_st_10k	; Stp_ndx==1

		ADDLW	0xFF
		BZ		LCD_st_100k	; Stp_ndx==2

		GOTO	LCD_st_1M	; Stp_ndx>=3
 endif

LCD_st_1k
 if MOD_type == MOD_FULL
		MOVLW	Sng_2sp_1k
		CALL	LCD_EEsngW
 else
		MOVLW	' '
		CALL	LCD_chr
		MOVLW	' '
		CALL	LCD_chr
		MOVLW	0x01
		CALL	LCD_dig
		MOVLW	'k'
		CALL	LCD_chr
 endif
		GOTO	LCD_st_Hz

LCD_st_10k
 if MOD_type == MOD_FULL
		MOVLW	Sng_sp_10k
		CALL	LCD_EEsngW
 else
		MOVLW	' '
		CALL	LCD_chr
		MOVLW	0x01
		CALL	LCD_dig
		MOVLW	0x00
		CALL	LCD_dig
		MOVLW	'k'
		CALL	LCD_chr
 endif
		GOTO	LCD_st_Hz

LCD_st_100k
 if MOD_type == MOD_FULL
		MOVLW	Sng_100k
		CALL	LCD_EEsngW
 else
		MOVLW	0x01
		CALL	LCD_dig
		MOVLW	0x00
		CALL	LCD_dig
		MOVLW	0x00
		CALL	LCD_dig
		MOVLW	'k'
		CALL	LCD_chr
 endif
		GOTO	LCD_st_Hz

LCD_st_1M
 if MOD_type == MOD_FULL
		MOVLW	Sng_2sp_1M
		CALL	LCD_EEsngW
 else
		MOVLW	' '
		CALL	LCD_chr
		MOVLW	' '
		CALL	LCD_chr
		MOVLW	0x01
		CALL	LCD_dig
		MOVLW	'M'
		CALL	LCD_chr
 endif

LCD_st_Hz
 if MOD_type == MOD_FULL
		MOVLW	Sng_Hz_qm
		GOTO	LCD_EEsngW	; And return from there
 else
		MOVLW	'H'
		CALL	LCD_chr
		MOVLW	'z'
		CALL	LCD_chr
		MOVLW	'-'
		CALL	LCD_chr
		MOVLW	'?'
		CALL	LCD_chr
		MOVLW	' '
		CALL	LCD_chr
		RETURN
 endif

;	Output of three voltages (Vi, V50, Vo) to LCD

LCD_3_volts
		CALL	Mv4_XY
		CLRF	Rgx_hh
		CLRF	Rgx_hl
		MOVLW	0x89
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		MOVLW	Sng_Vi_eq
		CALL	LCD_EEsngW
 else
		MOVLW	'V'
		CALL	LCD_chr
		MOVLW	'i'
		CALL	LCD_chr
		MOVLW	'='
		CALL	LCD_chr
 endif
 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 endif
		MOVF	Vi_h, W
		MOVWF	Rgx_lh
		MOVF	Vi_l, W
		MOVWF	Rgx_ll
		CALL	bin2bcd
		CALL	LCD_bcd_4

 if MOD_type == MOD_FULL
		BTFSS	Flags, Fl_upd5	; Update flag in new version
		GOTO	no_ech4

		MOVLW	' '
		CALL	putchr

no_ech4
		BCF		Nflgs, Nf_echo
 endif
		MOVLW	0xC0
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		MOVLW	Sng_V50_eq
		CALL	LCD_EEsngW
 else
		MOVLW	'V'
		CALL	LCD_chr
		MOVLW	'5'
		CALL	LCD_chr
		MOVLW	'0'
		CALL	LCD_chr
		MOVLW	'='
		CALL	LCD_chr
 endif
 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 endif
		MOVF	V50h, W
		MOVWF	Rgx_lh
		MOVF	V50l, W
		MOVWF	Rgx_ll
		CALL	bin2bcd
		CALL	LCD_bcd_4

		MOVLW	' '
		CALL	LCD_chr
 if MOD_type == MOD_FULL
		BCF		Nflgs, Nf_echo
 endif
		MOVLW	0xC9
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		MOVLW	Sng_Vo_eq
		CALL	LCD_EEsngW
 else
		MOVLW	'V'
		CALL	LCD_chr
		MOVLW	'o'
		CALL	LCD_chr
		MOVLW	'='
		CALL	LCD_chr
 endif
 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 endif
		MOVF	Vo_h, W
		MOVWF	Rgx_lh
		MOVF	Vo_l, W
		MOVWF	Rgx_ll
		CALL	bin2bcd
		CALL	LCD_bcd_4
 if MOD_type == MOD_FULL
		BTFSS	Flags, Fl_upd5	; Update flag in new version
		GOTO	no_ech3

		MOVLW	0x0D
		CALL	putchr
		MOVLW	0x0A
		CALL	putchr

no_ech3
		BCF		Nflgs, Nf_echo
		GOTO	Mv4_YX		; And return from there
 else
		CALL	Mv4_YX
		RETURN
 endif

;	Output of 4-digit BCD value to LCD

LCD_bcd_4
		SWAPF	Rg_bcd_1, W
		ANDLW	0x0F
		BZ		Label_0059

		CALL	LCD_dig
		GOTO	Label_005A

Label_0059
		MOVLW	' '
		CALL	LCD_chr
Label_005A
		MOVF	Rg_bcd_1, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		SWAPF	Rg_bcd_0, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		MOVF	Rg_bcd_0, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
		CALL	LCD_dig
		RETURN
 else
		GOTO	LCD_dig	; And return from there
 endif

;	Output of SWR, R, X to LCD

LCD_SRX
		CALL	Mv4_XY
		CLRF	Rgx_hh
		CLRF	Rgx_hl
		BSF		STATUS, RP0
		MOVF	Fp_rA, W
		MOVWF	Rgx_ll
		MOVF	Fp_rA+1, W
		MOVWF	Rgx_lh
		BCF		STATUS, RP0
		CALL	bin2bcd
		MOVLW	0x89
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		MOVLW	Sng_S_eq
		CALL	LCD_EEsngW
 else
		MOVLW	'S'
		CALL	LCD_chr
		MOVLW	'='
		CALL	LCD_chr
 endif
 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 endif
		MOVF	Rg_bcd_2, W
		BZ		Label_005B		; SWR is less than 100

 if MOD_type == MOD_FULL
		MOVLW	Sng_gt99
		CALL	LCD_EEsngW
 else
		MOVLW	' '
		CALL	LCD_chr
		MOVLW	'>'
		CALL	LCD_chr
		MOVLW	'9'
		CALL	LCD_chr
		MOVLW	'9'
		CALL	LCD_chr
  if MOD_type == MOD_FULL
		MOVLW	' '
		CALL	LCD_chr
  endif
 endif
		GOTO	Label_005C

Label_005B
 if MOD_type != MOD_FULL
		CLRF	Rg_bcd_4
 endif
		SWAPF	Rg_bcd_1, W
		ANDLW	0x0F
		BZ		Label_005D	; Replace leading zero by space

		CALL	LCD_dig
		GOTO	Label_005E

Label_005D
 if MOD_type != MOD_FULL
		INCF	Rg_bcd_4, f
 else
		MOVLW	' '
		CALL	LCD_chr
 endif

Label_005E
		MOVF	Rg_bcd_1, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		MOVLW	'.'
		CALL	LCD_chr
		SWAPF	Rg_bcd_0, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
		MOVLW	' '
		CALL	LCD_chr
;		MOVF	Rg_bcd_0, W
;		ANDLW	0x0F
;		CALL	LCD_dig
 if MOD_type != MOD_FULL
		MOVF	Rg_bcd_4, W
		BZ		Label_005C

		MOVLW	' '
		CALL	LCD_chr
 endif

Label_005C
 if MOD_type == MOD_FULL
		BCF		Nflgs, Nf_echo
 endif
		BSF		STATUS, RP0
		MOVF	Fp_r6, W
		MOVWF	Rgx_ll
		MOVF	Fp_r6+1, W
		MOVWF	Rgx_lh
		BCF		STATUS, RP0
		CALL	bin2bcd
		MOVLW	0xC0
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		MOVLW	Sng_R_eq
		CALL	LCD_EEsngW
 else
		MOVLW	'R'
		CALL	LCD_chr
		MOVLW	'='
		CALL	LCD_chr
 endif
		CALL	LCD_RX

 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 endif
		MOVLW	' '
		CALL	LCD_chr
 if MOD_type == MOD_FULL
		BCF		Nflgs, Nf_echo
 endif
		MOVLW	' '
		CALL	LCD_chr
		BSF		STATUS, RP0
		MOVF	Fp_r7, W
		MOVWF	Rgx_ll
		MOVF	Fp_r7+1, W
		MOVWF	Rgx_lh
		BCF		STATUS, RP0
		CALL	bin2bcd
		MOVLW	0xC9
		CALL	LCD_cmd
 if MOD_type == MOD_FULL
		MOVLW	Sng_X_eq
		CALL	LCD_EEsngW
 else
		MOVLW	'X'
		CALL	LCD_chr
		MOVLW	'='
		CALL	LCD_chr
 endif
		CALL	LCD_RX
 if MOD_type == MOD_FULL
		BTFSS	Flags, Fl_upd5	; Update flag in new version
		GOTO	no_ech1

		MOVLW	0x0D
		CALL	putchr
		MOVLW	0x0A
		CALL	putchr
no_ech1
		GOTO	Mv4_YX		; And return from here
 else
		CALL	Mv4_YX
		RETURN
 endif

;	R or X output to LCD

LCD_RX
 if MOD_type == MOD_FULL
		BSF		Nflgs, Nf_echo
 else
		CLRF	Rg_bcd_4	; Used as a counter for leading zeros
 endif
		SWAPF	Rg_bcd_1, W	; first digit (of four) is non-zero
		ANDLW	0x0F
		BNZ		Lcdrx_4dig	; Non-zero, output all 4

 if MOD_type != MOD_FULL
		INCF	Rg_bcd_4, f	; One zero is counted (1)
 else
		MOVLW	' '			; Put space instead
		CALL	LCD_chr
 endif
		MOVF	Rg_bcd_1, W	; Second digit
		ANDLW	0x0F
		BNZ		Lcdrx_3dig	; Non-zero, output 3 digits

 if MOD_type != MOD_FULL
		INCF	Rg_bcd_4, f	; One more zero is counted (2)
 else
		MOVLW	' '			; Put space instead
		CALL	LCD_chr
 endif
		SWAPF	Rg_bcd_0, W	; Third digit
		ANDLW	0x0F
		BNZ		Lcdrx_2dig	; Non-zero, output 2 digits

 if MOD_type != MOD_FULL
		INCF	Rg_bcd_4, f	; One more zero is counted (3)
 else
		MOVLW	' '			; Put space instead
		CALL	LCD_chr
 endif
		GOTO	Lcdrx_1dig

Lcdrx_4dig
		SWAPF	Rg_bcd_1, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
Lcdrx_3dig
		MOVF	Rg_bcd_1, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
Lcdrx_2dig
		SWAPF	Rg_bcd_0, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
Lcdrx_1dig
		MOVF	Rg_bcd_0, W
 if MOD_type != MOD_FULL
		ANDLW	0x0F
 endif
		CALL	LCD_dig
 if MOD_type == MOD_FULL
		BCF		Nflgs, Nf_echo
 endif
		MOVLW	0x00		; Omega character
 if MOD_type == MOD_FULL
		GOTO	LCD_chr		; And return from there
 else

Label_0064
		MOVF	Rg_bcd_4, W	; Skipped leading zero counter
		BTFSC	STATUS, Z
		RETURN

		MOVLW	' '
		CALL	LCD_chr		; Put trailing spaces instead
		DECF	Rg_bcd_4, f
		GOTO	Label_0064
 endif

;	Command output to LCD

LCD_cmd
		BCF		PORTA, PA_LCD_RS
		GOTO	Label_0065

;	Digit (nibble) output to LCD

LCD_dig
 if MOD_type == MOD_FULL
		ANDLW	0x0F
 endif
		ADDLW	'0'

;	Character output to LCD

LCD_chr
		BSF		PORTA, PA_LCD_RS
Label_0065
		MOVWF	Sym_LCD
 if MOD_type == MOD_FULL
		BTFSS	Nflgs, Nf_echo
		GOTO	no_echo

		BTFSC	Flags, Fl_upd5	; Update flag in new version
		CALL	putchr
no_echo
 endif
		MOVLW	0xF0
		ANDWF	PORTB, f
		SWAPF	Sym_LCD, W
		ANDLW	0x0F
		IORWF	PORTB, f
		BSF		PORTA, PA_LCD_EN
		NOP
		NOP
		BCF		PORTA, PA_LCD_EN
		CALL	Dly_x02
		MOVLW	0xF0
		ANDWF	PORTB, f
		MOVF	Sym_LCD, W
		ANDLW	0x0F
		IORWF	PORTB, f
		BSF		PORTA, PA_LCD_EN
		NOP
		NOP
		BCF		PORTA, PA_LCD_EN
 if MOD_type == MOD_FULL
		GOTO	Dly_x02		; And return from there
 else
		CALL	Dly_x02
		RETURN
 endif

Mv4_XY
		MOVLW	Rgx_hh
		MOVWF	Mv4_sptr
		MOVLW	Rgy_hh
		GOTO	Mv4_SpW

Mv4_YX
		MOVLW	Rgy_hh
		MOVWF	Mv4_sptr
		MOVLW	Rgx_hh
		GOTO	Mv4_SpW

Mv4_AB
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		GOTO	Mv4_SpW

Mv4_SpW
		MOVWF	Mv4_dptr
		MOVLW	0x04

 if MOD_type != MOD_FULL
;---------------- unused code start
		GOTO	Mv4_cmne

		MOVWF	Mv4_dptr
		MOVLW	0x06
Mv4_cmne
;---------------- unused code end
 endif

		MOVWF	Mv4_cntr
Mv4_loop
		MOVF	Mv4_sptr, W
		MOVWF	FSR
		MOVF	INDF, W
		MOVWF	Mv4_tmpv
		MOVF	Mv4_dptr, W
		MOVWF	FSR
		MOVF	Mv4_tmpv, W
		MOVWF	INDF
		INCF	Mv4_sptr, f
		INCF	Mv4_dptr, f
		DECFSZ	Mv4_cntr, f
		GOTO	Mv4_loop

		RETURN

Dly_x02
		MOVLW	0x02
		MOVWF	Dl1cth
		MOVLW	0x1F
		MOVWF	Dl1ctl
		GOTO	Dly_dctloop

		MOVLW	0x0B
		MOVWF	Dl1cth
		GOTO	Dly_dcnt

Dly_x21
		MOVLW	0x21
		MOVWF	Dl1cth
		GOTO	Dly_dcnt

Dly_x48
		MOVLW	0x48
		MOVWF	Dl1cth		; And fall to Dly_cnt in MOD_FULL

 if MOD_type != MOD_FULL
;---------------- unused code start
		GOTO	Dly_dcnt

		MOVLW	0x03
		MOVWF	Dl2cnt
		GOTO	Label_006C

		MOVLW	0x06
		MOVWF	Dl2cnt
Label_006C
		MOVLW	0xBA
		MOVWF	Dl1cth
		CALL	Dly_dcnt
		DECFSZ	Dl2cnt, f
		GOTO	Label_006C

		RETURN
;---------------- unused code end
 endif

Dly_dcnt
		MOVLW	0xFF
		MOVWF	Dl1ctl
Dly_dctloop
		NOP
		NOP
		NOP
		NOP
		DECFSZ	Dl1ctl, f
		GOTO	Dly_dctloop

		DECFSZ	Dl1cth, f
		GOTO	Dly_dcnt

		RETURN

Set_freq
		CLRF	FTW_ll
		CLRF	FTW_lh
		CLRF	FTW_hl
		CLRF	FTW_hh
		CLRF	FTW_ul
		MOVLW	D'32'
		MOVWF	Cmn_bcnt
 if MOD_type == MOD_FULL
		MOVLW	F0_prm
		MOVWF	Mv4_sptr
		MOVLW	Fstep_ll	; LSB first
		CALL	EE4_SpW
 else
		MOVLW	F0_val_B3	; 3f 43 7c ba - for 67.89 MHz
		MOVWF	Fstep_hh
		MOVLW	F0_val_B2
		MOVWF	Fstep_hl
		MOVLW	F0_val_B1
		MOVWF	Fstep_lh
		MOVLW	F0_val_B0
		MOVWF	Fstep_ll
 endif
		CALL	Mv4_XY		; Keep Rgx
Stf_loop
		BCF		STATUS, C
		BTFSS	Fstep_ll, 00
		GOTO	Label_006D

		MOVF	Rgx_ll, W
		ADDWF	FTW_lh, f
		BNC		Label_006E

		INCFSZ	FTW_hl, f
		GOTO	Label_006E

		INCFSZ	FTW_hh, f
		GOTO	Label_006E

		INCF	FTW_ul, f
Label_006E
		MOVF	Rgx_lh, W
		ADDWF	FTW_hl, f
		BNC		Label_006F

		INCFSZ	FTW_hh, f
		GOTO	Label_006F

		INCF	FTW_ul, f
Label_006F
		MOVF	Rgx_hl, W
		ADDWF	FTW_hh, f
		BNC		Label_0070

		INCF	FTW_ul, f
Label_0070
		MOVF	Rgx_hh, W
		ADDWF	FTW_ul, f
Label_006D
		RRF		FTW_ul, f
		RRF		FTW_hh, f
		RRF		FTW_hl, f
		RRF		FTW_lh, f
		RRF		FTW_ll, f
		RRF		Fstep_hh, f
		RRF		Fstep_hl, f
		RRF		Fstep_lh, f
		RRF		Fstep_ll, f
		DECFSZ	Cmn_bcnt, f
		GOTO	Stf_loop

		CLRF	FTW_ul
		CALL	Mv4_YX		; Restore Rgx
		CALL	Sel_fstp	; Restore Fstep

 if DDS_AD9834
		MOVLW	D'4'
		MOVWF	Cmn_bcnt

FTW_adj0
		RRF		FTW_hh, f	; CY isn't cleared !
		RRF		FTW_hl, f
		RRF		FTW_lh, f
		RRF		FTW_ll, f
		DECFSZ	Cmn_bcnt, f
		GOTO	FTW_adj0
 endif

		BTFSS	Flags, Fl_frgn	; FREG0/1?
		GOTO	Label_0072	; FREG0 in use

		BCF		Flags, Fl_frgn	; FREG1 in use, load FREG0
 if MOD_type == MOD_FULL
		GOTO	Lbl_72a
Label_0072					; FREG0 in use, load FREG1
		BSF		Flags, Fl_frgn
Lbl_72a
 endif
 if DDS_AD9834
		MOVF	FTW_ll, W	; 14 LSBs first
		MOVWF	DDS_wrdl
		MOVF	FTW_lh, W
		MOVWF	DDS_wrdh
		BCF		DDS_wrdh, 7
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		BSF		DDS_wrdh, 7
  endif
		BSF		DDS_wrdh, 6		; 01 - write to FREG0
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		BCF		DDS_wrdh, 6		; 10 - write to FREG1
  endif
		CALL	Snd_wrd16		; Bits [13:0]

		RLF		FTW_lh, f	; Two bits back
		RLF		FTW_hl, f
		RLF		FTW_hh, f
		RLF		FTW_lh, f
		RLF		FTW_hl, f
		RLF		FTW_hh, f

		MOVF	FTW_hl, W	; 14 MSBs next
		MOVWF	DDS_wrdl
		MOVF	FTW_hh, W
		MOVWF	DDS_wrdh
		BCF		DDS_wrdh, 7
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		BSF		DDS_wrdh, 7
  endif
		BSF		DDS_wrdh, 6		; 01 - write to FREG0
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		BCF		DDS_wrdh, 6		; 10 - write to FREG1
  endif
		CALL	Snd_wrd16		; Bits [27:14]

		MOVLW	B'00100000'	; DDS: B28, FSEL=0
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		MOVLW	B'00101000'	; DDS: B28, FSEL=1
  endif
		MOVWF	DDS_wrdh
		MOVLW	B'00000000'	; DDS:
		MOVWF	DDS_wrdl
 else
		MOVLW	0x30		; 30xx FREG0.LL=(FTW_ll)
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		MOVLW	0x34		; 34xx FREG1.LL=(FTW_ll)
  endif
		MOVWF	DDS_wrdh
		MOVF	FTW_ll, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x21		; 21xx FREG0.HL=(FTW_lh)
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		MOVLW	0x25
  endif
		MOVWF	DDS_wrdh
		MOVF	FTW_lh, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x32		; 32xx FREG0.LM=(FTW_hl)
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		MOVLW	0x36
  endif
		MOVWF	DDS_wrdh
		MOVF	FTW_hl, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x23		; 23xx FREG0.HM=(FTW_hh)
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		MOVLW	0x27
  endif
		MOVWF	DDS_wrdh
		MOVF	FTW_hh, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x50		; 50xx select FREG0
  if MOD_type == MOD_FULL
		BTFSC	Flags, Fl_frgn	; FREG0/1?
		MOVLW	0x58		; 58xx select FREG1
  endif
		MOVWF	DDS_wrdh
 endif
 if MOD_type == MOD_FULL
		GOTO	Snd_wrd16	; And return from there
 else
		CALL	Snd_wrd16
		RETURN
 endif

 if MOD_type != MOD_FULL
Label_0072					; FREG0 in use, load FREG1
		BSF		Flags, Fl_frgn
  if DDS_AD9834
		MOVF	FTW_ll, W	; 14 LSBs first
		MOVWF	DDS_wrdl
		MOVF	FTW_lh, W
		MOVWF	DDS_wrdh
		BSF		DDS_wrdh, 7
		BCF		DDS_wrdh, 6		; 10 - write to FREG1
		CALL	Snd_wrd16		; Bits [13:0]

		RLF		FTW_lh, f	; Two bits back
		RLF		FTW_hl, f
		RLF		FTW_hh, f
		RLF		FTW_lh, f
		RLF		FTW_hl, f
		RLF		FTW_hh, f

		MOVF	FTW_hl, W	; 14 MSBs next
		MOVWF	DDS_wrdl
		MOVF	FTW_hh, W
		MOVWF	DDS_wrdh
		BSF		DDS_wrdh, 7
		BCF		DDS_wrdh, 6		; 10 - write to FREG1
		CALL	Snd_wrd16		; Bits [27:14]

		MOVLW	B'00101000'	; DDS: B28, FSEL=1
		MOVWF	DDS_wrdh
		MOVLW	B'00000000'	; DDS:
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
  else
		MOVLW	0x34		; 34xx FREG1.LL=(FTW_ll)
		MOVWF	DDS_wrdh
		MOVF	FTW_ll, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x25
		MOVWF	DDS_wrdh
		MOVF	FTW_lh, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x36
		MOVWF	DDS_wrdh
		MOVF	FTW_hl, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x27
		MOVWF	DDS_wrdh
		MOVF	FTW_hh, W
		MOVWF	DDS_wrdl
		CALL	Snd_wrd16
		MOVLW	0x58		; 58xx select FREG1
		MOVWF	DDS_wrdh
		CALL	Snd_wrd16
  endif
		RETURN
 endif

Snd_wrd16
		MOVLW	D'16'
		MOVWF	Cmn_bcnt
 if DDS_AD9834
		BSF		PORTB, PB_DDS_SCK	; SCK high before select goes low
 endif
		BCF		PORTB, PB_DDS_NCS
Sndw16_1
		BCF		PORTB, PB_DDS_SDT
		BTFSC	DDS_wrdh, 07
		BSF		PORTB, PB_DDS_SDT
		BSF		PORTB, PB_DDS_SCK
		BCF		PORTB, PB_DDS_SCK
		RLF		DDS_wrdl, f
		RLF		DDS_wrdh, f
		DECFSZ	Cmn_bcnt, f
		GOTO	Sndw16_1

		BSF		PORTB, PB_DDS_NCS
		RETURN

Do_calc
		CLRF	AARGB0
		MOVF	Vi_h, W
		MOVWF	AARGB1
		MOVF	Vi_l, W
		MOVWF	AARGB2
		CALL	FLO2432		; A=Vi
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=Vi
		CLRF	AARGB0
		MOVF	V50h, W
		MOVWF	AARGB1
		MOVF	V50l, W
		MOVWF	AARGB2
		CALL	FLO2432		; A=V50
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r2
		CALL	Mv4_SpW		; r2=V50
		CALL	Mv4_AB		; B=V50
		CALL	FPM32		; A=V50^2
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r3
		CALL	Mv4_SpW		; r3=V50^2
		CLRF	AARGB0
		MOVF	Vo_h, W
		MOVWF	AARGB1
		MOVF	Vo_l, W
		MOVWF	AARGB2
		CALL	FLO2432		; A=Vo
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r4
		CALL	Mv4_SpW		; r4=Vo
		CALL	Mv4_AB		; B=Vo
		CALL	FPM32		; A=Vo^2
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r5
		CALL	Mv4_SpW		; r5=Vo^2
		MOVLW	Fp_r2
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=V50
		MOVLW	Fp_r4
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=Vo
		CALL	FPA32		; A=V50+Vo
		CALL	Mv4_AB		; B=V50+Vo
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r7
		CALL	Mv4_SpW		; r7=V50+Vo
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=Vi
		CALL	FPS32		; A=Vi-(V50+Vo)
		BTFSC	AARGB0, 07
		GOTO	Label_0079	; Vi<=(V50+Vo)

		MOVLW	Fp_r7		; Vi>(V50+Vo)
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=V50+Vo (fixed Vi)

Label_0079
		MOVLW	Fp_r3
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=V50^2
		MOVLW	Fp_r5
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=Vo^2
		CALL	FPA32		; A=V50^2+Vo^2
		CALL	Sqrt_A		; A=SQRT(V50^2+Vo^2)
		CALL	Mv4_AB		; B=SQRT(V50^2+Vo^2)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r7
		CALL	Mv4_SpW		; r7=SQRT(V50^2+Vo^2)
		MOVLW	Fp_r0		; Vi
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=Vi
		CALL	FPS32		; A=Vi-SQRT(V50^2+Vo^2)
		BTFSS	AARGB0, 07
		GOTO	Label_007B	; Vi>SQRT(V50^2+Vo^2)

		MOVLW	Fp_r7		; Vi<=SQRT(V50^2+Vo^2)
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=SQRT(V50^2+Vo^2) (fixed Vi)

Label_007B
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=Vi
		CALL	Mv4_AB		; B=Vi
		CALL	FPM32		; A=Vi^2
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r1
		CALL	Mv4_SpW		; r1=Vi^2
		MOVLW	Fp_r3
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=V50^2
		MOVLW	Fp_r5
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=Vo^2
		CALL	FPA32		; A=V50^2+Vo^2
		CALL	Mv4_AB		; B=V50^2+Vo^2
		MOVLW	Fp_r1
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=Vi^2
		CALL	FPS32		; A=Vi^2-(V50^2+Vo^2)
		MOVLW	Fp_r3
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=V50^2
		CALL	FPD32		; A=(Vi^2-(V50^2+Vo^2))/V50^2
		CALL	Ld_two_B	; B=2
		CALL	FPD32		; A=(Vi^2-(V50^2+Vo^2))/(2*V50^2)
		CALL	Sel_Z0_B	; B=50
		CALL	FPM32		; A=50*(Vi^2-(V50^2+Vo^2))/(2*V50^2)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r6
		CALL	Mv4_SpW		; r6=R=50*(Vi^2-(V50^2+Vo^2))/(2*V50^2)
		MOVLW	Fp_r5
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=Vo^2
		MOVLW	Fp_r3
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=V50^2
		CALL	FPD32		; A=Vo^2/V50^2
		CALL	Sel_Z0_B	; B=50
		CALL	FPM32		; A=50*Vo^2/V50^2
		CALL	Sel_Z0_B	; B=50
		CALL	FPM32		; A=50^2*Vo^2/V50^2
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=50^2*Vo^2/V50^2
		MOVLW	Fp_r6
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=R
		CALL	Mv4_AB		; B=R
		CALL	FPM32		; A=R^2
		CALL	Mv4_AB		; B=R^2
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=50^2*Vo^2/V50^2
		CALL	FPS32		; A=50^2*Vo^2/V50^2-R^2
		BCF		AARGB0, 07	; A=|50^2*Vo^2/V50^2-R^2|
		CALL	Sqrt_A		; A=SQRT(|50^2*Vo^2/V50^2-R^2|)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r7
		CALL	Mv4_SpW		; r7=X=SQRT(|50^2*Vo^2/V50^2-R^2|)
		MOVLW	Fp_r6
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=R
		CALL	Sel_Z0_B	; B=50
		CALL	FPA32		; A=50+R
		CALL	Mv4_AB		; B=50+R
		CALL	FPM32		; A=(50+R)^2
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=(50+R)^2
		MOVLW	Fp_r7
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=X
		CALL	Mv4_AB		; B=X
		CALL	FPM32		; A=X^2
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=(50+R)^2
		CALL	FPA32		; A=(50+R)^2+X^2
		CALL	Sqrt_A		; A=SQRT((50+R)^2+X^2)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r8
		CALL	Mv4_SpW		; r8=SA=SQRT((50+R)^2+X^2)
		MOVLW	Fp_r6
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=R
		CALL	Sel_Z0_B	; B=50
		CALL	FPS32		; A=R-50
		BCF		AARGB0, 07	; A=|R-50|
		CALL	Mv4_AB		; B=|R-50|
		CALL	FPM32		; A=(R-50)^2
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=(R-50)^2
		MOVLW	Fp_r7
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=X
		CALL	Mv4_AB		; B=X
		CALL	FPM32		; A=X^2
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=(R-50)^2
		CALL	FPA32		; A=(R-50)^2+X^2
		CALL	Sqrt_A		; A=SQRT((R-50)^2+X^2)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r9
		CALL	Mv4_SpW		; r9=SB=SQRT((R-50)^2+X^2)
		MOVLW	Fp_r8
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=SA
		MOVLW	Fp_r9
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=SB
		CALL	FPA32		; A=SA+SB
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r0
		CALL	Mv4_SpW		; r0=SA+SB
		MOVLW	Fp_r8
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=SA
		MOVLW	Fp_r9
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=SB
		CALL	FPS32		; A=SA-SB
; if MOD_type == MOD_FULL
 if 0 ; ### Fix SWR
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=SA+SB
		CALL	FPD32		; A=1/SWR=(SA-SB)/(SA+SB)
		BCF		AARGB0, 07	; A=|(SA-SB)/(SA+SB)|
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_rA
		CALL	Mv4_SpW		; rA=1/SWR
		MOVLW	0x78		; 78 00 00 00 -> (2^(0x78-0x7F))*(0x80/128) = 2^-7=1/128
		MOVWF	BEXP
		CLRF	BARGB0
		CLRF	BARGB1
		CLRF	BARGB2
		CALL	FPS32		; A=1/SWR-1/128
		BTFSC	AARGB0, 07
		GOTO	Fix_SWR		; SWR is too high

		MOVLW	0x7F		; 7F 00 00 00 -> (2^(0x7F-0x7F))*(0x80/128) = 2^0=1
		MOVWF	AEXP
		CLRF	AARGB0
		CLRF	AARGB1
		CLRF	AARGB2
		MOVLW	Fp_rA
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW		; B=1/SWR
		CALL	FPD32		; A=SWR
		GOTO	Cont_SWR

Fix_SWR
		MOVLW	0x85		; 85 48 00 00 -> (2^(0x85-0x7F))*(0xC8/128) = 100
		MOVWF	AEXP
		MOVLW	0x48
		MOVWF	AARGB0
		CLRF	AARGB1
		CLRF	AARGB2		; A=100
 else
		CALL	Mv4_AB		; B=SA-SB
		MOVLW	Fp_r0
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=SA+SB
		CALL	FPD32		; A=SWR=(SA+SB)/(SA-SB)
 endif
Cont_SWR
		MOVLW	0x85		; 85 48 00 00 -> (2^(0x85-0x7F))*(0xC8/128) = 100
		MOVWF	BEXP
		MOVLW	0x48
		MOVWF	BARGB0
		CLRF	BARGB1
		CLRF	BARGB2		; B=100
		CALL	FPM32		; A=SWR*100
		CALL	INT3224		; A=int(SWR*100)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_rA
		CALL	Mv4_SpW		; rA=int(SWR*100)

		MOVLW	Fp_r6
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=R
		CALL	INT3224		; A=int(R)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r6
		CALL	Mv4_SpW		; r6=int(R)

		MOVLW	Fp_r7
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW		; A=X
		CALL	INT3224		; A=int(X)
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_r7
 if MOD_type == MOD_FULL
		GOTO	Mv4_SpW		; r7=int(X) and return from there
 else
		CALL	Mv4_SpW		; r7=int(X)
		RETURN
 endif

Sqrt_A
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_sq_a
		CALL	Mv4_SpW
		CALL	Ld_two_B
		CALL	FPD32
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_sq_b
		CALL	Mv4_SpW
		MOVLW	0x10
		MOVWF	Cmn_bcnt
Label_0080
		CALL	Mv4_AB
		MOVLW	Fp_sq_a
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
		CALL	Mv4_SpW
		CALL	FPD32
		MOVLW	Fp_sq_b
		MOVWF	Mv4_sptr
		MOVLW	BARGB2
		CALL	Mv4_SpW
		CALL	FPA32
		CALL	Ld_two_B
		CALL	FPD32
		MOVLW	AARGB2
		MOVWF	Mv4_sptr
		MOVLW	Fp_sq_b
		CALL	Mv4_SpW
		DECFSZ	Cmn_bcnt, f
		GOTO	Label_0080

		MOVLW	Fp_sq_b
		MOVWF	Mv4_sptr
		MOVLW	AARGB2
 if MOD_type == MOD_FULL
		GOTO	Mv4_SpW		; And return from there
 else
		CALL	Mv4_SpW
		RETURN
 endif

Ld_two_B
		MOVLW	0x80	; 80 00 00 00 -> 2^1 = 2
		MOVWF	BEXP
		CLRF	BARGB0
		CLRF	BARGB1
		CLRF	BARGB2
		RETURN

Sel_Z0_B
		MOVF	Z0_ptr, W
 if MOD_type == MOD_FULL
		ADDLW	Tb_Z0
		MOVWF	Mv4_sptr
		MOVLW	BARGB2	; LSB first: BARGB2, BARGB1, BARGB0, BEXP
		GOTO	EE4_SpW	; And return from there
 else
		CALL	Z0_tbl
		MOVWF	BEXP
		INCF	Z0_ptr, W
		CALL	Z0_tbl
		MOVWF	BARGB0
		CLRF	BARGB1
		CLRF	BARGB2
		RETURN
 endif

		include "FP32.A16"

 if MOD_type == MOD_FULL
;********************************************************
;	Serial Output Routines, initially written by
;	Phil Rice VK3BHR for 4 MHz clock and 9600 Baud:
;	9600 Baud = 104.17 us = 104.17 CPU cycles
;	For internal RC oscillator 8 MHz clock it
;	gives near 20000 Baud output with Phil's constants,
;	so they were adjusted slightly
;********************************************************

putchr
		movwf	S_Wtemp		; Character being output
		BCF		INTCON, GIE
		bcf		PORTA, PA_COM_TXD	; Send a 0 - Start bit
		movlw	11			; (1) Bit count: start, 8 data, 2 stop
		movwf	S_count		; (1)

ptcbit						; 2 from last bit
		nop					; (1)
		movlw	0xE9		; (1) Delay for 104 cycles N=100h-e9h=17h=23
txd_0						; 4 from last data bit
		addlw	0x01		; (1)
		bnz		txd_0		; (3/2) 4*(N-1)+3=4*N-1=99
							; 4*N+3 from last bit
		decf	S_count, f	; (1) Done all bits?
		bz		ptcret		; (3/2)
							; 4*N+6 from last bit
		bsf		STATUS, C	; (1) fill by ones to get stop bits
		rrf		S_Wtemp, f	; (1) Transmit a bit
		bc		ptcone		; (3/2)
							; 4*N+10 from last bit
		nop					; (1)
		bcf		PORTA, PA_COM_TXD	; (1) Send a 0, 4*N+12 from last bit
		goto	ptcbit		; (2)

ptcone						; 4*N+11 from last bit
		bsf		PORTA, PA_COM_TXD	; (1) Send a 1, 4*N+12 from last bit
		goto	ptcbit		; (2)

ptcret
		BSF		INTCON, GIE
		return

;********************************************************
;	EEPROM access routines, taken from FCL-meter by EU1CC
;********************************************************

LCD_EEsngW					; ASCIZ string pointed by W
		bsf		STATUS, RP1
		movwf	EEADR
LCD_EEsngF
		call	EEchrF
		andlw	0xFF
		btfsc	STATUS, Z
		return

		call	LCD_chr
		bsf		STATUS, RP1
		incf	EEADR, F
		goto	LCD_EEsngF

EEchrW						; Char pointed by W
		bsf		STATUS, RP1
		movwf	EEADR
EEchrF						; Char pointed by EEADR
		bsf		STATUS, RP0
		bsf		EECON1, RD	; EEPROM read request
		bcf		STATUS, RP0
		movf	EEDATA, W
		bcf		STATUS, RP1
		return

EE4_SpW
		MOVWF	Mv4_dptr
		MOVLW	0x04
		MOVWF	Mv4_cntr

EE4_loop
		MOVF	Mv4_sptr, W
		call	EEchrW
		MOVWF	Mv4_tmpv
		MOVF	Mv4_dptr, W
		MOVWF	FSR
		MOVF	Mv4_tmpv, W
		MOVWF	INDF
		INCF	Mv4_sptr, f
		INCF	Mv4_dptr, f
		DECFSZ	Mv4_cntr, f
		GOTO	EE4_loop

		RETURN

		ORG		0x2100	; EEPROM area

EEstart	EQU		$

;	Start with F0 constant, 4 bytes, LSB first

F0_prm		EQU	$-EEstart
	DE		F0_val_B0, F0_val_B1, F0_val_B2, F0_val_B3

;	Power-on frequency, 4 bytes, MSB first

Strt_fq		EQU	$-EEstart
	DE		0x00, 0x6B, 0x93, 0x10	; 0x006b9310=7050000

;	Frequency step table, LSB first

Tb_fstp		EQU	$-EEstart
	DE		0xE8, 0x03, 0x00, 0x00	; 0x000003e8=1000
	DE		0x10, 0x27, 0x00, 0x00	; 0x00002710=10000
	DE		0xA0, 0x86, 0x01, 0x00	; 0x000186a0=100000
	DE		0x40, 0x42, 0x0F, 0x00	; 0x000f4240=1000000

;	Z0 table, LSB first: BARGB2, BARGB1, BARGB0, BEXP

Tb_Z0		EQU	$-EEstart
	DE		0, 0, 0x16, 0x88	; 88 16 00 00 -> (2^(0x88-0x7F))*(0x96/128) = 600
	DE		0, 0, 0x16, 0x87	; 87 16 00 00 -> (2^(0x87-0x7F))*(0x96/128) = 300
	DE		0, 0, 0x16, 0x85	; 85 16 00 00 -> (2^(0x85-0x7F))*(0x96/128) = 75
	DE		0, 0, 0x48, 0x84	; 84 48 00 00 -> (2^(0x84-0x7F))*(0xC8/128) = 50

;	ASCII zero-terminated strings

Sng_gt99	EQU	$-EEstart
	DE	" >99 \0"

Sng_Hz_eq	EQU	$-EEstart
	DE	"Hz=\0"

Sng_kHz_sp	EQU	$-EEstart
	DE	"kHz \0"

Sng_2sp_1k	EQU	$-EEstart
	DE	"  1k\0"

Sng_sp_10k	EQU	$-EEstart
	DE	" 10k\0"

Sng_100k	EQU	$-EEstart
	DE	"100k\0"

Sng_2sp_1M	EQU	$-EEstart
	DE	"  1M\0"

Sng_Hz_qm	EQU	$-EEstart
	DE	"Hz-? \0"

Sng_Vi_eq	EQU	$-EEstart
	DE	"Vi=\0"

Sng_V50_eq	EQU	$-EEstart
	DE	"V50=\0"

Sng_Vo_eq	EQU	$-EEstart
	DE	"Vo=\0"

Sng_S_eq	EQU	$-EEstart
	DE	"S=\0"

Sng_R_eq	EQU	$-EEstart
	DE	"R=\0"

Sng_X_eq	EQU	$-EEstart
	DE	"X=\0"


 endif
		END
